#!/usr/bin/perl


use XML::Parser;
use strict;
use vars qw($key %vcard);

my $p= new XML::Parser(Style => 'Stream');
$p->parsefile($ARGV[0]);

sub StartTag {
  my $p = shift;
  $key = shift;
}

sub EndTag {
  my $p = shift;
  my $t = shift;
  undef $key;
  if ($t eq "vcard") {
    printVcard(%vcard);
  }
}


sub Text {
  return if (! defined($key) || $key eq "vcard" || $key eq "adressen");
  $vcard{$key} = $_;
}

sub printVcard {
  my (%hash) = @_;
  print "begin:vcard\n";
  print "n:$hash{'nachname'};$hash{'vorname'}\n";
  print "fn: $hash{'vorname'} $hash{'nachname'}\n";
  if (exists $hash{'strasse'} && exists $hash{'plz'} &&
      exists $hash{'ort'}) {
    print "adr:;;$hash{'strasse'};$hash{'ort'};;$hash{'plz'};Germany\n";
  }
  print "tel;work:$hash{'telgesch'}\n" if (exists $hash{'telgesch'});
  print "tel;fax;work:$hash{'faxgesch'}\n" if (exists $hash{'faxgesch'});
  print "email;internet:$hash{'mail'}\n" if (exists $hash{'mail'});
  print "end:vcard\n";
}
